@use "sass:map";
@use "sass:meta";
@use "sass:string";
@use "sass:math";
@use "sass:color";

@use "tokens" as tokens;
@use "assets" as assets;
//@use "utils/functions" as utils;


/*  =============================================================
    PRIMITIVE TOKEN FUNCTIONS
============================================================== */

// returns a primitive token value
@function primitive-token($category, $token) {
    @if map.has-key(tokens.$primitive-tokens, $category, $token) {
        @return map.get(tokens.$primitive-tokens, $category, $token);        
    }

    @else {
        @warn "no primitive token found with #{$category} #{$token}.";
        @return "not found primitive #{$category} #{$token}";
    }
}

// shorter pprimitive token function
@function p-token($category, $token) {
    @return primitive-token($category, $token);
}

// even shorter primitive token function
@function pt($category, $token) {
    @return primitive-token($category, $token);
}


/*  =============================================================
    APP TOKEN FUNCTIONS
============================================================== */

// returns an app token css var
@function app-token($category, $token, $fallback: null) {

    $mode: 'default';

    @if map.has-key(tokens.$app-tokens, $mode, $category, $token) {
        @if type-of(map.get(tokens.$app-tokens, $mode, $category, $token)) !=map {
            @return var(--#{tokens.$token-identifier}#{$category}-#{$token});
        }

        @else {
            @warn 'no simple app-token found with #{$category} #{$token}. use composit-token function instead';
            @if $fallback == null {
                @return "not found app token #{$category} #{$token} and no fallback set";
            } @else {
                @return var(--#{tokens.$token-identifier}#{$category}-#{$token}, #{$fallback});
            }
        }
    }

    @else {
        @warn "no app token found with #{$category} #{$token}.";
        @if $fallback == null {
            @return "not found app token #{$category} #{$token} and no fallback set";
        } @else {
            @return var(--#{tokens.$token-identifier}#{$category}-#{$token}, #{$fallback});
        }
    }
}

// shorter app token function
@function a-token($category, $token, $fallback: null) {
    @return app-token($category, $token, $fallback);
}

// even shorter app token function
@function at($category, $token, $fallback: null) {
    @return app-token($category, $token, $fallback);
}


/*  =============================================================
    APP COMPOSIT TOKEN FUNCTIONS
============================================================== */

// returns an app composit token
@function app-composit-token($category, $token, $token-part, $fallback: null) {
    
    $mode: 'default';

    @if map.has-key(tokens.$app-tokens, $mode, $category, $token, $token-part) {
        @if type-of(map.get(tokens.$app-tokens, $mode, $category, $token))==map {
            @return var(--#{tokens.$token-identifier}#{$category}-#{$token}-#{$token-part});
        }

        @else {
            @warn 'no composit app-token found with #{$category} #{$token} #{$token-part}. use simple function instead';
            
            @if $fallback == null {
                @return 'not found app composit token #{$category} #{$token} #{$token-part} and no fallback set.';
            } @else {
                @return var(--#{tokens.$token-identifier}#{$category}-#{$token}-#{$token-part}, #{$fallback});
            }
        }
    }

    @else {
        @warn "no app token found with #{$category} #{$token} #{$token-part}.";
    
        @if $fallback == null {
            @return 'not found app token#{$category} #{$token} #{$token-part} and no fallback set.';
        } @else {
            @return var(--#{tokens.$token-identifier}#{$category}-#{$token}-#{$token-part}, #{$fallback});
        }

    }
}

// shorter app composit token function
@function ac-token($category, $token, $token-part, $fallback: null) {
    @return app-composit-token($category, $token, $token-part, $fallback);
}

// even shorter app composit token function
@function act($category, $token, $token-part, $fallback: null) {
    @return app-composit-token($category, $token, $token-part, $fallback);
}



/*  =============================================================
    COMPONENT TOKEN FUNCTIONS
============================================================== */

// returns a component token
@function component-token($component, $token, $fallback: null) {
    @if $fallback == null {
        @return var(--#{$component}-#{$token});        
    } @else {
        @return var(--#{$component}-#{$token}, #{$fallback});        
    }
}

// shorter component token function
@function c-token($category, $token, $fallback: null) {
    @return component-token($category, $token, $fallback);
}

// even shorter component token function
@function ct($category, $token, $fallback: null) {
    @return component-token($category, $token, $fallback);
}



/*  =============================================================
    ALIAS FUNCTIONS FOR FASTER ACCESS TO IMPORTANT APP TOKENS
============================================================== */

// returns a app css var based on the name
@function app($token, $fallback: null) {
    $category: 'app';
    @return app-token($category, $token, $fallback);
}

// returns the app edge padding
@function edge-padding() {
    $category: 'app';
    $token: 'edge-padding';
    @return app-token($category, $token);
}

// returns a grid css var based on the name
@function grid($token, $fallback: null) {
    $category: 'grid';
    @return app-token($category, $token, $fallback);
}

// returns a color css var based on the name
@function color($token, $fallback: null) {
    $category: 'color';
    @return app-token($category, $token, $fallback);
}

// returns a space css var based on the name
@function space($token, $fallback: null) {
    $category: 'space';
    @return app-token($category, $token, $fallback);
}

// returns a size css var based on the name
@function size($token, $fallback: null) {
    $category: 'size';
    @return app-token($category, $token, $fallback);
}

// returns a height css var based on the name
@function height($token, $fallback: null) {
    $category: 'height';
    @return app-token($category, $token, $fallback);
}

// returns a width css var based on the name
@function width($token, $fallback: null) {
    $category: 'width';
    @return app-token($category, $token, $fallback);
}

// returns a container css var based on the name
@function container($token, $fallback: null) {
    $category: 'container';
    @return app-token($category, $token, $fallback);
}

// returns a breakpoint css var based on the name
@function breakpoint($token, $fallback: null) {
    $category: 'breakpoint';
    @return app-token($category, $token, $fallback);
}

// returns a transition css var based on the name
@function transition($token, $fallback: null) {
    $category: 'transition';
    @return app-token($category, $token, $fallback);
}

// returns a radius css var based on the name
@function radius($token, $fallback: null) {
    $category: 'radius';
    @return app-token($category, $token, $fallback);
}

// returns a shadow css var based on the name
@function shadow($token, $fallback: null) {
    $category: 'shadow';
    @return app-token($category, $token, $fallback);
}

// returns a border css var based on the name
@function border($token, $fallback: null) {
    $category: 'border';
    @return app-token($category, $token, $fallback);
}

// returns a elevation css var based on the name
@function elevation($token, $fallback: null) {
    $category: 'elevation';
    @return app-token($category, $token, $fallback);
}

// returns font-size based on name
@function font-size($token, $fallback: null) {
    $category: 'type';
    $token-part: 'font-size';
    @return app-composit-token($category, $token, $token-part, $fallback);
}

// returns line-height based on name
@function line-height($token, $fallback: null) {
    $category: 'type';
    $token-part: 'line-height';
    @return app-composit-token($category, $token, $token-part, $fallback);
}

// returns font-weight based on name
@function font-weight($token, $fallback: null) {
    $category: 'type';
    $token-part: 'font-weight';
    @return app-composit-token($category, $token, $token-part, $fallback);
}

// returns fornt-family based on name
@function font-family($token, $fallback: null) {
    $category: 'type';
    $token-part: 'font-family';
    @return app-composit-token($category, $token, $token-part, $fallback);
}



/*  =============================================================
    Grid specific Functions
============================================================== */

// return the grid column as calc



@function grid-column($column) {
    @return calc((100% / #{app-token('grid', 'columns')}) * #{$column});
}






/*  =============================================================
    RETURNS A STORED SVG ICON FROM ASSETS OR A PASSED SVG IN ENCODED FORM
============================================================== */

@function svg-icon($icon, $color: 'currentColor') {
    
    @if meta.type-of($icon) == 'string' {
        @if string.index($icon, '<svg') {
            // It's an SVG string
            $svg: $icon;
            $svg: str-replace($svg, 'var(--adm-icon-color)', $color);
            $svg-encoded: svg-url-encode($svg);
            @return url('data:image/svg+xml,#{$svg-encoded}');
        } @else if map.has-key(assets.$icons, $icon) {
            $svg: map.get(assets.$icons, $icon);
            $svg: str-replace($svg, 'var(--adm-icon-color)', $color);
            $svg-encoded: svg-url-encode($svg);
            @return url('data:image/svg+xml,#{$svg-encoded}');
        } @else {
            @warn "Icon #{$icon} not found.";
            @return null;
        }
    } @else {
        @warn "#{$icon} is no string and not found in Icons";
        @return null;
    }
}




/*  =============================================================
    Unit Functions
============================================================== */

// function to convert a hsl value to hsla
@function hsla($hsl, $alpha: 1) {
    @warn "Deprecated function hsla(), will be removed in 6.0. Use to-hsla() instead.";
    @return color.change($hsl, $alpha: $alpha);
} 

@function to-hsla($hsl, $alpha: 1) {
    @return color.change($hsl, $alpha: $alpha);
} 

// function to convert a dimension to rem
@function rem($value) {
    @warn "Deprecated function rem(), will be removed in 6.0. Use to-rem() instead.";
    @return math.div($value, 16) * 1rem;
}
@function to-rem($value, $base-font-size: 16) {
    @return math.div($value, $base-font-size) * 1rem;
}

// function to convert a dimension to px
@function px($pixel) {
    @warn "Deprecated function px(), will be removed in 6.0. Use to-px() instead.";
    @return "#{$pixel}px";
}

@function to-px($value) {
    @if not unitless($value) {
        @return math.div($value, 1px) * 1px;
    } @else {
        @return $value * 1px;
    }
}

// function to convert a dimension to %
@function percent($value) {
    @warn "Deprecated function percent(), will be removed in 6.0. Use to-percent() instead";
    @return "#{$value}%";
}
@function to-percent($value) {
    @if not unitless($value) {
        @return math.div($value, 1%) * 1%;
    } @else {
        @return $value * 1%;
    }
}








/*  =============================================================
    Utils Functions
============================================================== */


// function to replace a string
@function str-replace($string, $search, $replace: '') {
  
    $index: string.index($string, $search);
    @if $index {
      @return string.slice($string, 1, $index - 1) + $replace + str-replace(string.slice($string, $index + string.length($search)), $search, $replace);
    }
    @return $string;
  }
  
  // svg url encoding function
  @function svg-url-encode($string) {
      $map: (
        "%": "%25",
        "<": "%3C",
        ">": "%3E",
        "!": "%21",
        "*": "%2A",
        "'": "%27",
        '"': "%22",
        "(": "%28",
        ")": "%29",
        ";": "%3B",
        ":": "%3A",
        "@": "%40",
        "&": "%26",
        "=": "%3D",
        "+": "%2B",
        "$": "%24",
        ",": "%2C",
        "/": "%2F",
        "?": "%3F",
        "#": "%23",
        "[": "%5B",
        "]": "%5D",
      );
      @each $search, $replace in $map {
        $string: str-replace($string, $search, $replace);
      }
      @return $string;
    }
  
  
  // function to remove units from values
  @function strip-unit($number) {
      @if type-of($number) == "number" and not unitless($number) {
          @return math.div($number, ($number * 0 + 1));
      }
      @return $number;
  }
  


